/*
hhxdmp.c Version 0.1.0  Hash print database in hex
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void hhxdmp(hashfmt *hshhdr, char *tag)
   {
   BOOL  bResult;
   DWORD msgerr;
   LPVOID lpMsgBuf;
   int eofsw;
   DWORD rdlen;
   unsigned int adr;
   DWORD loc;
   unsigned char buf[32];
   hshhdr->reason = 0;
   loc = SetFilePointer(hshhdr->hndl,
      (long) 0,NULL,FILE_BEGIN);
   if (loc == UINT_MAX)
      {
      msgerr = GetLastError();
      hshhdr->reason = SYS_ERR + msgerr;
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
         FORMAT_MESSAGE_FROM_SYSTEM |
         FORMAT_MESSAGE_IGNORE_INSERTS,
         NULL,           /* source */
         msgerr,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
         (LPTSTR) &lpMsgBuf,
         0,              /* msglen */
         NULL);          /* insertion values */
      fprintf(stderr,"hhxdmp: %s\n", lpMsgBuf);
      LocalFree(lpMsgBuf);
      fprintf(stderr,"hhxdmp: SetFilePointer "
         "error in %s\n", hshhdr->dbname);
      return;
      } /* if lseek err */
   printf("hhxdmp: %s\n", tag);
   eofsw = 0;
   adr = 0;
   while (!eofsw)
      {
      bResult = ReadFile(hshhdr->hndl,
         (unsigned char *) buf,
         (DWORD) 16,
         &rdlen,
         NULL);
      if (!bResult)
	 {
         msgerr = GetLastError();
         hshhdr->reason = SYS_ERR + msgerr;
         FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
            FORMAT_MESSAGE_FROM_SYSTEM |
            FORMAT_MESSAGE_IGNORE_INSERTS,
            NULL,           /* source */
            msgerr,
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
            (LPTSTR) &lpMsgBuf,
            0,              /* msglen */
            NULL);          /* insertion values */
         fprintf(stderr,"hhxdmp: %s\n", lpMsgBuf);
         LocalFree(lpMsgBuf);
         hshhdr->reason = SYS_ERR + msgerr;
         return;
	 } /* read err */
      if (!rdlen)
	 {
	 eofsw = 1;
         break;
	 } /* eof */
      hputhx(adr,rdlen,buf);
      adr += 16;
      } /* for each 16 bytes */
   } /* hhxdmp */
